#include <bits/stdc++.h>

using namespace std;

#define ll long long

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    for(int i = 0; i < t; i++)
    {
        bool moze = true;
        int n, m;
        cin >> n >> m;
        ll a[n], b[m];
        for(int i = 0; i < n; i++)
            cin >> a[i];
        for(int j = 0; j < m; j++)
            cin >> b[j];
        sort(a, a+n);
        ll x = a[1]-a[0];
        for(int i = 2; i < n; i++)
            x = __gcd(x, a[i] - a[i-1]);
        for(int i = 0; i < m; i++)
        {
            if(abs(b[i] - a[0]) % x == 0)
            {
                moze = false;
                break;
            }
        }
        cout << moze << "\n";
    }
    return 0;
}